// C Source File
// Created 7/12/00; 5:44:41 PM

// #define USE_GRAY_PATCH
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define RETURN_VALUE dat


#include <nostub.h>  // NoStub Program
#include <estack.h>  // Support Expression Stack
#include <vat.h>     // VAT access routines
#include <events.h>  // Event handling
#include <alloc.h>   // for HeapDeref function
#include <string.h>  // for strcpy and strcat functions

int _ti89;           // Produce .89Z File

int OK = 0;          // set to 1 later if the user didn't press ESC in Var-Link 
SYM_ENTRY *SymPtr = 0;  // Pointer to VAT entry


// Event Handler for capturing the user's choice from the Var-Link dialog
// For more information on event handlers, see Zeljco Juric's TIGCCLIB documentation.
void Handler(EVENT* ev)
{
	OK = 1;     // If this function is called, it means the user pressed ENTER, not ESC.
	EV_defaultHandler(ev);  // Required line, frees memory taken by Var-Link
};

// Main Function
int _main()
{
	EVENT keyp;                    // Declares a variable of EVENT type, used to start Var-Link later on 
	char folder[9];                
	char *buffer = "                    ";  
	OK = 0;                        // Make sure OK is 0
	EV_captureEvents(Handler);     // install my event handler, see TIGCCLIB docs 
	SymFindPtr($(select),0)->flags.bits.hidden = 1;  //hide this program so the user can't delete it while its running
	keyp.Type = CM_KEYPRESS;       // making Var-Link keypress
	keyp.extra.Key.Code = 4141;    //   "        "
	EV_defaultHandler(&keyp);      // open Var-Link - lots of stuff happens due to this statement, before the program continues
	EV_captureEvents(NULL);        // Var-Link now closed, re-install previous event handler
	SymFindPtr($(select),0)->flags.bits.hidden = 0;  // unhide this program so the user can see it after it exits
	if (OK == 0)                   // if user pressed escape, Handler was never called, so OK is still 0 
	{
		push_END_TAG();            
		push_ANSI_string ("ESC");     // this code constructs this list: {"ESC"}
		push_LIST_TAG();
		return 0;
	};
	push_END_TAG ();               // end-of-list tag, pushed first (list is backwards)
	SymPtr = SymFindFirst(NULL,6); // sets SymPtr to first folder in folder/file list
	while (SymPtr)                 // while there are still files/folders left
	{
		if (SymPtr->flags.bits.folder) // if this is a folder, save its name to variable folder
		{
			strcpy(folder,SymPtr->name);
		}
		else       // if it is not a folder, it must be a file
		{
		        if (SymPtr->flags.bits.checked)  // if this file is checked 
		        {
		                push_ANSI_string(strcat(strcat(strcpy(buffer,folder),"\\"),SymPtr->name)); // add the folder name to the variable name, and add this to the list
		        };
		};
		SymPtr = SymFindNext ();     // set SymPtr to next folder/variable
	};
	push_LIST_TAG ();              // list tag, added to the list last
	return 0;
};  // THE END :->
